@Library(['build-share','deploy-share','scan-shared','total_pipeline']) _
pipeline_scripted()

    // node {
        // stage('checkout scm'){
        //     deleteDir()
        //     checkout scm
        // }
        // stage('deploy in container'){
        //     deploy_dev()
        // }
        
        // stage('complite'){
        //     maven_build()
        // }
        // stage('unitest'){
        //     maven_test()
        // }
        // stage('sonar scan'){
        //    sonar(installationName: 'SonarQube Server', credentialsId: "${env.credentialsId_sonar}")
        // }
        // stage('upload artifact to nexus'){
        // //    def libraryResult = mavenInfo()
                // nexus(groupId: 'UAT')
        //         // url: '192.168.20.20:8081',
        //         // repository:'snapshot',
        //         // file: '/workspace/library/target/spring-petclinic-3.1.0-SNAPSHOT.jar'  
        //         // )
        // //    echo "ArtifactId: ${libraryResult.ArtifactId}"
        //     sh "chmod +x ./mvnw && ./mvnw deploy -DskipTests -Dcheckstyle.skip -DrepositoryId=UAT -DartifactId=spring-petclinic -Durl='192.168.20.20:8081' -Dusername=${env.user_nexus} -Dpassword=${env.password_nexus}"
        // }
        // stage('pull artifacts on  vm uat'){
        //     pull_repo(url: 'http://192.168.20.20:8081/repository/Petclinic-UAT/UAT/spring-petclinic/100_1693027727_snapshot/spring-petclinic-100_1693027727_snapshot.jar',
        //     repo: 'app_uat', user_nexus: "${env.user_nexus}", password_nexus: "${env.password_nexus}")
        // }
        // stage('deploy environments VM'){
        //     deploy(inventoryPath:'ansible/inventory', playbookPath:'playbook.yml',
        //     serviceNames:'uat', servicePorts:'8080')
        // }
        // stage('docker build image '){
        //     docker_build(
        //     image_name: 'petclinic-dl', repo_url_dev: '192.168.20.20:8088',
        //     repo_url_product: '192.168.20.20:8089'
        //     )
        // }
        // stage('deploy in container'){
        //     // deploy_container(
        //     // agent: 'ssh-agent', remoteUser: 'root',
        //     // dev_port: '8888',
        //     // // product_port: '9999',
        //     // remoteHost: '192.168.20.30', 
        //     // image_dev: '192.168.20.20:8088/petclinic-dl:latest',
        //     // // image_product: '192.168.20.20:8089/petclinic-dl:latest',
        //     // container_name_dev: 'petclinic-dl-dev', 
        //     // // container_name_product: 'petclinic-dl-product',
        //     // repo_url_dev: '192.168.20.20:8088',
        //     // // repo_url_product: '192.168.20.20:8089'
        //     // )
        //     deploy_dev()
        // }
        // stage('check conatiner'){
        //     check_container(
        //     agent: 'ssh-agent', remoteUser: 'root',
        //     port: '8888',
        //     remoteHost: '192.168.20.30', image_name: '192.168.20.20:8088/petclinic-dl:latest',
        //     container_name: 'petclinic-dl', 
        //     repo_url: '192.168.20.20:8088'
        //     )
        // }
        // stage('add tag branch git'){
        //     add_tag()
        // }
        // stage('check health'){
        //     check_health(url: '192.168.20.40', port: '8080')
        // }
    // }